/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSSlider;

import dstep.appkit.NSColor;
import dstep.appkit.NSControl;
import dstep.appkit.NSCell;
import dstep.appkit.NSEvent;
import dstep.appkit.NSFont;
import dstep.appkit.NSImage;
import dstep.appkit.NSSliderCell;
import dstep.applicationservices.coregraphics.CGBase;
import dstep.foundation.NSObjCRuntime;
import dstep.foundation.NSString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSSlider : NSControl
{
	mixin (ObjcWrap);

	double minValue ()
	{
		return invokeObjcSelf!(double, "minValue");
	}

	void setMinValue (double aDouble)
	{
		return invokeObjcSelf!(void, "setMinValue:", double)(aDouble);
	}

	double maxValue ()
	{
		return invokeObjcSelf!(double, "maxValue");
	}

	void setMaxValue (double aDouble)
	{
		return invokeObjcSelf!(void, "setMaxValue:", double)(aDouble);
	}

	void setAltIncrementValue (double incValue)
	{
		return invokeObjcSelf!(void, "setAltIncrementValue:", double)(incValue);
	}

	double altIncrementValue ()
	{
		return invokeObjcSelf!(double, "altIncrementValue");
	}

	void setTitleCell (NSCell aCell)
	{
		return invokeObjcSelf!(void, "setTitleCell:", NSCell)(aCell);
	}

	Object titleCell ()
	{
		return invokeObjcSelf!(Object, "titleCell");
	}

	void setTitleColor (NSColor newColor)
	{
		return invokeObjcSelf!(void, "setTitleColor:", NSColor)(newColor);
	}

	NSColor titleColor ()
	{
		return invokeObjcSelf!(NSColor, "titleColor");
	}

	void setTitleFont (NSFont fontObj)
	{
		return invokeObjcSelf!(void, "setTitleFont:", NSFont)(fontObj);
	}

	NSFont titleFont ()
	{
		return invokeObjcSelf!(NSFont, "titleFont");
	}

	NSString title ()
	{
		return invokeObjcSelf!(NSString, "title");
	}

	void setTitle (NSString aString)
	{
		return invokeObjcSelf!(void, "setTitle:", NSString)(aString);
	}

	void setKnobThickness (CGFloat aFloat)
	{
		return invokeObjcSelf!(void, "setKnobThickness:", CGFloat)(aFloat);
	}

	CGFloat knobThickness ()
	{
		return invokeObjcSelf!(CGFloat, "knobThickness");
	}

	void setImage (NSImage backgroundImage)
	{
		return invokeObjcSelf!(void, "setImage:", NSImage)(backgroundImage);
	}

	NSImage image ()
	{
		return invokeObjcSelf!(NSImage, "image");
	}

	NSInteger isVertical ()
	{
		return invokeObjcSelf!(NSInteger, "isVertical");
	}

	bool acceptsFirstMouse (NSEvent theEvent)
	{
		return invokeObjcSelf!(bool, "acceptsFirstMouse:", NSEvent)(theEvent);
	}
}

