/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 30, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.coreaudio.AudioDriverPlugIn;

import dstep.coreaudio.AudioHardware;
import dstep.coreaudio.CoreAudioTypes;
import dstep.coreservices.ae.AEMach;

private alias mach_port_t io_object_t;

extern (C)
{
	alias int function (AudioDeviceID inDevice, uint inChannel, bool isInput, AudioDevicePropertyID inPropertyID) AudioDriverPlugInDevicePropertyChangedProc;
	alias int function (AudioDeviceID inDevice, io_object_t inIOAudioStream, uint inChannel, AudioDevicePropertyID inPropertyID) AudioDriverPlugInStreamPropertyChangedProc;
}

struct AudioDriverPlugInHostInfo
{
	uint mDeviceID;
	uint mIOAudioDevice;
	uint mIOAudioEngine;
	AudioDriverPlugInDevicePropertyChangedProc mDevicePropertyChangedProc;
	AudioDriverPlugInStreamPropertyChangedProc mStreamPropertyChangedProc;
}

extern (C)
{
	int AudioDriverPlugInOpen (AudioDriverPlugInHostInfo* inHostInfo);
	int AudioDriverPlugInClose (uint inDevice);
	int AudioDriverPlugInDeviceGetPropertyInfo (uint inDevice, uint inChannel, ubyte isInput, uint inPropertyID, uint* outSize, char* outWritable);
	int AudioDriverPlugInDeviceGetProperty (uint inDevice, uint inChannel, ubyte isInput, uint inPropertyID, uint* ioPropertyDataSize, void* outPropertyData);
	int AudioDriverPlugInDeviceSetProperty (uint inDevice, AudioTimeStamp* inWhen, uint inChannel, ubyte isInput, uint inPropertyID, uint inPropertyDataSize, void* inPropertyData);
	int AudioDriverPlugInStreamGetPropertyInfo (uint inDevice, uint inIOAudioStream, uint inChannel, uint inPropertyID, uint* outSize, char* outWritable);
	int AudioDriverPlugInStreamGetProperty (uint inDevice, uint inIOAudioStream, uint inChannel, uint inPropertyID, uint* ioPropertyDataSize, void* outPropertyData);
	int AudioDriverPlugInStreamSetProperty (uint inDevice, uint inIOAudioStream, AudioTimeStamp* inWhen, uint inChannel, uint inPropertyID, uint inPropertyDataSize, void* inPropertyData);
}