/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 25, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.coredata.NSFetchRequestExpression;

import dstep.foundation.NSExpression;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

enum
{
	NSFetchRequestExpressionType = 50
}

class NSFetchRequestExpression : NSExpression
{
	mixin (ObjcWrap);

	static NSExpression expressionForFetch (NSExpression fetch, NSExpression context, bool countFlag)
	{
		return invokeObjcSelfClass!(NSExpression, "expressionForFetch:context:countOnly:", NSExpression, NSExpression, bool)(fetch, context, countFlag);
	}

	NSExpression requestExpression ()
	{
		return invokeObjcSelf!(NSExpression, "requestExpression");
	}

	NSExpression contextExpression ()
	{
		return invokeObjcSelf!(NSExpression, "contextExpression");
	}

	bool isCountOnlyRequest ()
	{
		return invokeObjcSelf!(bool, "isCountOnlyRequest");
	}
}

