/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 12, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.corefoundation.CFAttributedString;

import dstep.corefoundation.CFBase;
import dstep.corefoundation.CFDictionary;
import dstep.corefoundation.CFString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc : id;

struct __CFAttributedString;
alias __CFAttributedString* CFAttributedStringRef;
alias __CFAttributedString* CFMutableAttributedStringRef;

extern (C)
{
	uint CFAttributedStringGetTypeID ();
	CFAttributedStringRef CFAttributedStringCreate (CFAllocatorRef alloc, CFStringRef str, CFDictionaryRef attributes);
	CFAttributedStringRef CFAttributedStringCreateWithSubstring (CFAllocatorRef alloc, CFAttributedStringRef aStr, CFRange range);
	CFAttributedStringRef CFAttributedStringCreateCopy (CFAllocatorRef alloc, CFAttributedStringRef aStr);
	CFStringRef CFAttributedStringGetString (CFAttributedStringRef aStr);
	int CFAttributedStringGetLength (CFAttributedStringRef aStr);
	CFDictionaryRef CFAttributedStringGetAttributes (CFAttributedStringRef aStr, int loc, CFRange* effectiveRange);
	void* CFAttributedStringGetAttribute (CFAttributedStringRef aStr, int loc, CFStringRef attrName, CFRange* effectiveRange);
	CFDictionaryRef CFAttributedStringGetAttributesAndLongestEffectiveRange (CFAttributedStringRef aStr, int loc, CFRange inRange, CFRange* longestEffectiveRange);
	void* CFAttributedStringGetAttributeAndLongestEffectiveRange (CFAttributedStringRef aStr, int loc, CFStringRef attrName, CFRange inRange, CFRange* longestEffectiveRange);
	CFMutableAttributedStringRef CFAttributedStringCreateMutableCopy (CFAllocatorRef alloc, int maxLength, CFAttributedStringRef aStr);
	CFMutableAttributedStringRef CFAttributedStringCreateMutable (CFAllocatorRef alloc, int maxLength);
	void CFAttributedStringReplaceString (CFMutableAttributedStringRef aStr, CFRange range, CFStringRef replacement);
	CFMutableStringRef CFAttributedStringGetMutableString (CFMutableAttributedStringRef aStr);
	void CFAttributedStringSetAttributes (CFMutableAttributedStringRef aStr, CFRange range, CFDictionaryRef replacement, ubyte clearOtherAttributes);
	void CFAttributedStringSetAttribute (CFMutableAttributedStringRef aStr, CFRange range, CFStringRef attrName, void* value);
	void CFAttributedStringRemoveAttribute (CFMutableAttributedStringRef aStr, CFRange range, CFStringRef attrName);
	void CFAttributedStringReplaceAttributedString (CFMutableAttributedStringRef aStr, CFRange range, CFAttributedStringRef replacement);
	void CFAttributedStringBeginEditing (CFMutableAttributedStringRef aStr);
	void CFAttributedStringEndEditing (CFMutableAttributedStringRef aStr);
}