/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 22, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.coreservices.cfnetwork.CFNetworkErrors;

//import dstep.Availability;
import dstep.coreservices.cfnetwork.CFNetworkDefs;
import dstep.corefoundation.CFBase;
import dstep.corefoundation.CFString;

alias int CFNetworkErrors;

extern (C)
{
	extern
	{
		const CFStringRef kCFErrorDomainCFNetwork;
		const CFStringRef kCFErrorDomainWinSock;
		const CFStringRef kCFGetAddrInfoFailureKey;
		const CFStringRef kCFSOCKSStatusCodeKey;
		const CFStringRef kCFSOCKSVersionKey;
		const CFStringRef kCFSOCKSNegotiationMethodKey;
		const CFStringRef kCFDNSServiceFailureKey;
		const CFStringRef kCFFTPStatusCodeKey;
	}
}

enum /*CFNetworkErrors*/ 
{
	kCFHostErrorHostNotFound = 1,
	kCFHostErrorUnknown = 2,
	kCFSOCKSErrorUnknownClientVersion = 100,
	kCFSOCKSErrorUnsupportedServerVersion = 101,
	kCFSOCKS4ErrorRequestFailed = 110,
	kCFSOCKS4ErrorIdentdFailed = 111,
	kCFSOCKS4ErrorIdConflict = 112,
	kCFSOCKS4ErrorUnknownStatusCode = 113,
	kCFSOCKS5ErrorBadState = 120,
	kCFSOCKS5ErrorBadResponseAddr = 121,
	kCFSOCKS5ErrorBadCredentials = 122,
	kCFSOCKS5ErrorUnsupportedNegotiationMethod = 123,
	kCFSOCKS5ErrorNoAcceptableMethod = 124,
	kCFNetServiceErrorUnknown = -72000L,
	kCFNetServiceErrorCollision = -72001L,
	kCFNetServiceErrorNotFound = -72002L,
	kCFNetServiceErrorInProgress = -72003L,
	kCFNetServiceErrorBadArgument = -72004L,
	kCFNetServiceErrorCancel = -72005L,
	kCFNetServiceErrorInvalid = -72006L,
	kCFNetServiceErrorTimeout = -72007L,
	kCFNetServiceErrorDNSServiceFailure = -73000L,
	kCFFTPErrorUnexpectedStatusCode = 200,
	kCFErrorHTTPAuthenticationTypeUnsupported = 300,
	kCFErrorHTTPBadCredentials = 301,
	kCFErrorHTTPConnectionLost = 302,
	kCFErrorHTTPParseFailure = 303,
	kCFErrorHTTPRedirectionLoopDetected = 304,
	kCFErrorHTTPBadURL = 305,
	kCFErrorHTTPProxyConnectionFailure = 306,
	kCFErrorHTTPBadProxyCredentials = 307,
	kCFErrorPACFileError = 308
}

