/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSHFSFileTypes;

import dstep.corefoundation.CFBase;
import dstep.foundation.NSObjCRuntime;
import dstep.foundation.NSString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;



import bindings = dstep.foundation.NSHFSFileTypes_bindings;

NSString NSFileTypeForHFSTypeCode (uint hfsFileTypeCode)
{
	return Bridge.invokeObjcFunction!(NSString, bindings.NSFileTypeForHFSTypeCode, uint)(hfsFileTypeCode);
}

uint NSHFSTypeCodeFromFileType (NSString fileTypeString)
{
	return Bridge.invokeObjcFunction!(uint, bindings.NSHFSTypeCodeFromFileType, NSString)(fileTypeString);
}

NSString NSHFSTypeOfFile (NSString fullFilePath)
{
	return Bridge.invokeObjcFunction!(NSString, bindings.NSHFSTypeOfFile, NSString)(fullFilePath);
}

