/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSXMLDTDNode;

import dstep.foundation.NSObjCRuntime;
import dstep.foundation.NSString;
import dstep.foundation.NSXMLNode;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

alias NSUInteger NSXMLDTDNodeKind;

enum
{
	NSXMLEntityGeneralKind = 1,
	NSXMLEntityParsedKind,
	NSXMLEntityUnparsedKind,
	NSXMLEntityParameterKind,
	NSXMLEntityPredefined,
	NSXMLAttributeCDATAKind,
	NSXMLAttributeIDKind,
	NSXMLAttributeIDRefKind,
	NSXMLAttributeIDRefsKind,
	NSXMLAttributeEntityKind,
	NSXMLAttributeEntitiesKind,
	NSXMLAttributeNMTokenKind,
	NSXMLAttributeNMTokensKind,
	NSXMLAttributeEnumerationKind,
	NSXMLAttributeNotationKind,
	NSXMLElementDeclarationUndefinedKind,
	NSXMLElementDeclarationEmptyKind,
	NSXMLElementDeclarationAnyKind,
	NSXMLElementDeclarationMixedKind,
	NSXMLElementDeclarationElementKind
}

class NSXMLDTDNode : NSXMLNode
{
	mixin (ObjcWrap);
	
	this ()
	{
		super(typeof(this).alloc.init.objcObject);
	}
	
	typeof(this) init ()
	{
		return invokeObjcSelf!(typeof(this), "init");
	}

	Object initWithXMLString (NSString string)
	{
		return invokeObjcSelf!(Object, "initWithXMLString:", NSString)(string);
	}

	this (NSString string)
	{
		typeof(this).alloc.initWithXMLString(string);
	}

	void setDTDKind (uint kind)
	{
		return invokeObjcSelf!(void, "setDTDKind:", uint)(kind);
	}

	uint DTDKind ()
	{
		return invokeObjcSelf!(uint, "DTDKind");
	}

	bool isExternal ()
	{
		return invokeObjcSelf!(bool, "isExternal");
	}

	void setPublicID (NSString publicID)
	{
		return invokeObjcSelf!(void, "setPublicID:", NSString)(publicID);
	}

	NSString publicID ()
	{
		return invokeObjcSelf!(NSString, "publicID");
	}

	void setSystemID (NSString systemID)
	{
		return invokeObjcSelf!(void, "setSystemID:", NSString)(systemID);
	}

	NSString systemID ()
	{
		return invokeObjcSelf!(NSString, "systemID");
	}

	void setNotationName (NSString notationName)
	{
		return invokeObjcSelf!(void, "setNotationName:", NSString)(notationName);
	}

	NSString notationName ()
	{
		return invokeObjcSelf!(NSString, "notationName");
	}
}

