/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.opengl.glext;

import dstep.opengl.gl;

alias byte GLcharARB;
alias void* GLhandleARB;
alias int GLintptrARB;
alias int GLsizeiptrARB;

extern (C)
{
	void glActiveTextureARB (uint dummy);
	void glClientActiveTextureARB (uint dummy);
	void glMultiTexCoord1dARB (uint dummy, double dummy);
	void glMultiTexCoord1dvARB (uint dummy, GLdouble* dummy);
	void glMultiTexCoord1fARB (uint dummy, float dummy);
	void glMultiTexCoord1fvARB (uint dummy, GLfloat* dummy);
	void glMultiTexCoord1iARB (uint dummy, int dummy);
	void glMultiTexCoord1ivARB (uint dummy, GLint* dummy);
	void glMultiTexCoord1sARB (uint dummy, short dummy);
	void glMultiTexCoord1svARB (uint dummy, GLshort* dummy);
	void glMultiTexCoord2dARB (uint dummy, double dummy, double dummy);
	void glMultiTexCoord2dvARB (uint dummy, GLdouble* dummy);
	void glMultiTexCoord2fARB (uint dummy, float dummy, float dummy);
	void glMultiTexCoord2fvARB (uint dummy, GLfloat* dummy);
	void glMultiTexCoord2iARB (uint dummy, int dummy, int dummy);
	void glMultiTexCoord2ivARB (uint dummy, GLint* dummy);
	void glMultiTexCoord2sARB (uint dummy, short dummy, short dummy);
	void glMultiTexCoord2svARB (uint dummy, GLshort* dummy);
	void glMultiTexCoord3dARB (uint dummy, double dummy, double dummy, double dummy);
	void glMultiTexCoord3dvARB (uint dummy, GLdouble* dummy);
	void glMultiTexCoord3fARB (uint dummy, float dummy, float dummy, float dummy);
	void glMultiTexCoord3fvARB (uint dummy, GLfloat* dummy);
	void glMultiTexCoord3iARB (uint dummy, int dummy, int dummy, int dummy);
	void glMultiTexCoord3ivARB (uint dummy, GLint* dummy);
	void glMultiTexCoord3sARB (uint dummy, short dummy, short dummy, short dummy);
	void glMultiTexCoord3svARB (uint dummy, GLshort* dummy);
	void glMultiTexCoord4dARB (uint dummy, double dummy, double dummy, double dummy, double dummy);
	void glMultiTexCoord4dvARB (uint dummy, GLdouble* dummy);
	void glMultiTexCoord4fARB (uint dummy, float dummy, float dummy, float dummy, float dummy);
	void glMultiTexCoord4fvARB (uint dummy, GLfloat* dummy);
	void glMultiTexCoord4iARB (uint dummy, int dummy, int dummy, int dummy, int dummy);
	void glMultiTexCoord4ivARB (uint dummy, GLint* dummy);
	void glMultiTexCoord4sARB (uint dummy, short dummy, short dummy, short dummy, short dummy);
	void glMultiTexCoord4svARB (uint dummy, GLshort* dummy);
	void glLoadTransposeMatrixfARB (GLfloat* dummy);
	void glLoadTransposeMatrixdARB (GLdouble* dummy);
	void glMultTransposeMatrixfARB (GLfloat* dummy);
	void glMultTransposeMatrixdARB (GLdouble* dummy);
	void glSampleCoverageARB (float dummy, ubyte dummy);
	void glSamplePassARB (uint dummy);
	void glCompressedTexImage3DARB (uint dummy, int dummy, uint dummy, int dummy, int dummy, int dummy, int dummy, int dummy, GLvoid* dummy);
	void glCompressedTexImage2DARB (uint dummy, int dummy, uint dummy, int dummy, int dummy, int dummy, int dummy, GLvoid* dummy);
	void glCompressedTexImage1DARB (uint dummy, int dummy, uint dummy, int dummy, int dummy, int dummy, GLvoid* dummy);
	void glCompressedTexSubImage3DARB (uint dummy, int dummy, int dummy, int dummy, int dummy, int dummy, int dummy, int dummy, uint dummy, int dummy, GLvoid* dummy);
	void glCompressedTexSubImage2DARB (uint dummy, int dummy, int dummy, int dummy, int dummy, int dummy, uint dummy, int dummy, GLvoid* dummy);
	void glCompressedTexSubImage1DARB (uint dummy, int dummy, int dummy, int dummy, uint dummy, int dummy, GLvoid* dummy);
	void glGetCompressedTexImageARB (uint dummy, int dummy, GLvoid* dummy);
	void glWeightbvARB (int dummy, char* dummy);
	void glWeightsvARB (int dummy, GLshort* dummy);
	void glWeightivARB (int dummy, GLint* dummy);
	void glWeightfvARB (int dummy, GLfloat* dummy);
	void glWeightdvARB (int dummy, GLdouble* dummy);
	void glWeightubvARB (int dummy, char* dummy);
	void glWeightusvARB (int dummy, GLushort* dummy);
	void glWeightuivARB (int dummy, GLuint* dummy);
	void glWeightPointerARB (int dummy, uint dummy, int dummy, GLvoid* dummy);
	void glVertexBlendARB (int dummy);
	void glWindowPos2dARB (double dummy, double dummy);
	void glWindowPos2dvARB (GLdouble* dummy);
	void glWindowPos2fARB (float dummy, float dummy);
	void glWindowPos2fvARB (GLfloat* dummy);
	void glWindowPos2iARB (int dummy, int dummy);
	void glWindowPos2ivARB (GLint* dummy);
	void glWindowPos2sARB (short dummy, short dummy);
	void glWindowPos2svARB (GLshort* dummy);
	void glWindowPos3dARB (double dummy, double dummy, double dummy);
	void glWindowPos3dvARB (GLdouble* dummy);
	void glWindowPos3fARB (float dummy, float dummy, float dummy);
	void glWindowPos3fvARB (GLfloat* dummy);
	void glWindowPos3iARB (int dummy, int dummy, int dummy);
	void glWindowPos3ivARB (GLint* dummy);
	void glWindowPos3sARB (short dummy, short dummy, short dummy);
	void glWindowPos3svARB (GLshort* dummy);
	void glGenQueriesARB (int n, GLuint* ids);
	void glDeleteQueriesARB (int n, GLuint* ids);
	ubyte glIsQueryARB (uint id);
	void glBeginQueryARB (uint target, uint id);
	void glEndQueryARB (uint target);
	void glGetQueryivARB (uint target, uint pname, GLint* params);
	void glGetQueryObjectivARB (uint id, uint pname, GLint* params);
	void glGetQueryObjectuivARB (uint id, uint pname, GLuint* params);
	void glPointParameterfARB (uint pname, float param);
	void glPointParameterfvARB (uint pname, GLfloat* params);
	void glBindProgramARB (uint target, uint program);
	void glDeleteProgramsARB (int n, GLuint* programs);
	void glGenProgramsARB (int n, GLuint* programs);
	ubyte glIsProgramARB (uint program);
	void glProgramEnvParameter4dARB (uint target, uint index, double x, double y, double z, double w);
	void glProgramEnvParameter4dvARB (uint target, uint index, GLdouble* params);
	void glProgramEnvParameter4fARB (uint target, uint index, float x, float y, float z, float w);
	void glProgramEnvParameter4fvARB (uint target, uint index, GLfloat* params);
	void glProgramLocalParameter4dARB (uint target, uint index, double x, double y, double z, double w);
	void glProgramLocalParameter4dvARB (uint target, uint index, GLdouble* params);
	void glProgramLocalParameter4fARB (uint target, uint index, float x, float y, float z, float w);
	void glProgramLocalParameter4fvARB (uint target, uint index, GLfloat* params);
	void glGetProgramEnvParameterdvARB (uint target, uint index, GLdouble* params);
	void glGetProgramEnvParameterfvARB (uint target, uint index, GLfloat* params);
	void glProgramEnvParameters4fvEXT (uint target, uint index, int count, GLfloat* params);
	void glProgramLocalParameters4fvEXT (uint target, uint index, int count, GLfloat* params);
	void glGetProgramLocalParameterdvARB (uint target, uint index, GLdouble* params);
	void glGetProgramLocalParameterfvARB (uint target, uint index, GLfloat* params);
	void glProgramStringARB (uint target, uint format, int len, GLvoid* string);
	void glGetProgramStringARB (uint target, uint pname, GLvoid* string);
	void glGetProgramivARB (uint target, uint pname, GLint* params);
	void glVertexAttrib1dARB (uint index, double x);
	void glVertexAttrib1dvARB (uint index, GLdouble* v);
	void glVertexAttrib1fARB (uint index, float x);
	void glVertexAttrib1fvARB (uint index, GLfloat* v);
	void glVertexAttrib1sARB (uint index, short x);
	void glVertexAttrib1svARB (uint index, GLshort* v);
	void glVertexAttrib2dARB (uint index, double x, double y);
	void glVertexAttrib2dvARB (uint index, GLdouble* v);
	void glVertexAttrib2fARB (uint index, float x, float y);
	void glVertexAttrib2fvARB (uint index, GLfloat* v);
	void glVertexAttrib2sARB (uint index, short x, short y);
	void glVertexAttrib2svARB (uint index, GLshort* v);
	void glVertexAttrib3dARB (uint index, double x, double y, double z);
	void glVertexAttrib3dvARB (uint index, GLdouble* v);
	void glVertexAttrib3fARB (uint index, float x, float y, float z);
	void glVertexAttrib3fvARB (uint index, GLfloat* v);
	void glVertexAttrib3sARB (uint index, short x, short y, short z);
	void glVertexAttrib3svARB (uint index, GLshort* v);
	void glVertexAttrib4NbvARB (uint index, char* v);
	void glVertexAttrib4NivARB (uint index, GLint* v);
	void glVertexAttrib4NsvARB (uint index, GLshort* v);
	void glVertexAttrib4NubARB (uint index, ubyte x, ubyte y, ubyte z, ubyte w);
	void glVertexAttrib4NubvARB (uint index, char* v);
	void glVertexAttrib4NuivARB (uint index, GLuint* v);
	void glVertexAttrib4NusvARB (uint index, GLushort* v);
	void glVertexAttrib4bvARB (uint index, char* v);
	void glVertexAttrib4dARB (uint index, double x, double y, double z, double w);
	void glVertexAttrib4dvARB (uint index, GLdouble* v);
	void glVertexAttrib4fARB (uint index, float x, float y, float z, float w);
	void glVertexAttrib4fvARB (uint index, GLfloat* v);
	void glVertexAttrib4ivARB (uint index, GLint* v);
	void glVertexAttrib4sARB (uint index, short x, short y, short z, short w);
	void glVertexAttrib4svARB (uint index, GLshort* v);
	void glVertexAttrib4ubvARB (uint index, char* v);
	void glVertexAttrib4uivARB (uint index, GLuint* v);
	void glVertexAttrib4usvARB (uint index, GLushort* v);
	void glVertexAttribPointerARB (uint index, int size, uint type, ubyte normalized, int stride, GLvoid* pointer);
	void glDisableVertexAttribArrayARB (uint index);
	void glEnableVertexAttribArrayARB (uint index);
	void glGetVertexAttribPointervARB (uint index, uint pname, GLvoid** pointer);
	void glGetVertexAttribdvARB (uint index, uint pname, GLdouble* params);
	void glGetVertexAttribfvARB (uint index, uint pname, GLfloat* params);
	void glGetVertexAttribivARB (uint index, uint pname, GLint* params);
	void glDeleteObjectARB (GLhandleARB obj);
	GLhandleARB glGetHandleARB (uint pname);
	void glDetachObjectARB (GLhandleARB containerObj, GLhandleARB attachedObj);
	GLhandleARB glCreateShaderObjectARB (uint shaderType);
	void glShaderSourceARB (GLhandleARB shaderObj, int count, GLcharARB** string, GLint* length);
	void glCompileShaderARB (GLhandleARB shaderObj);
	GLhandleARB glCreateProgramObjectARB ();
	void glAttachObjectARB (GLhandleARB containerObj, GLhandleARB obj);
	void glLinkProgramARB (GLhandleARB programObj);
	void glUseProgramObjectARB (GLhandleARB programObj);
	void glValidateProgramARB (GLhandleARB programObj);
	void glUniform1fARB (int location, float v0);
	void glUniform2fARB (int location, float v0, float v1);
	void glUniform3fARB (int location, float v0, float v1, float v2);
	void glUniform4fARB (int location, float v0, float v1, float v2, float v3);
	void glUniform1iARB (int location, int v0);
	void glUniform2iARB (int location, int v0, int v1);
	void glUniform3iARB (int location, int v0, int v1, int v2);
	void glUniform4iARB (int location, int v0, int v1, int v2, int v3);
	void glUniform1fvARB (int location, int count, GLfloat* value);
	void glUniform2fvARB (int location, int count, GLfloat* value);
	void glUniform3fvARB (int location, int count, GLfloat* value);
	void glUniform4fvARB (int location, int count, GLfloat* value);
	void glUniform1ivARB (int location, int count, GLint* value);
	void glUniform2ivARB (int location, int count, GLint* value);
	void glUniform3ivARB (int location, int count, GLint* value);
	void glUniform4ivARB (int location, int count, GLint* value);
	void glUniformMatrix2fvARB (int location, int count, ubyte transpose, GLfloat* value);
	void glUniformMatrix3fvARB (int location, int count, ubyte transpose, GLfloat* value);
	void glUniformMatrix4fvARB (int location, int count, ubyte transpose, GLfloat* value);
	void glGetObjectParameterfvARB (GLhandleARB obj, uint pname, GLfloat* params);
	void glGetObjectParameterivARB (GLhandleARB obj, uint pname, GLint* params);
	void glGetInfoLogARB (GLhandleARB obj, int maxLength, GLsizei* length, char* infoLog);
	void glGetAttachedObjectsARB (GLhandleARB containerObj, int maxCount, GLsizei* count, GLhandleARB* obj);
	int glGetUniformLocationARB (GLhandleARB programObj, char* name);
	void glGetActiveUniformARB (GLhandleARB programObj, uint index, int maxLength, GLsizei* length, GLint* size, GLenum* type, char* name);
	void glGetUniformfvARB (GLhandleARB programObj, int location, GLfloat* params);
	void glGetUniformivARB (GLhandleARB programObj, int location, GLint* params);
	void glGetShaderSourceARB (GLhandleARB obj, int maxLength, GLsizei* length, char* source);
	void glBindAttribLocationARB (GLhandleARB programObj, uint index, char* name);
	void glGetActiveAttribARB (GLhandleARB programObj, uint index, int maxLength, GLsizei* length, GLint* size, GLenum* type, char* name);
	int glGetAttribLocationARB (GLhandleARB programObj, char* name);
	void glBindBufferARB (uint target, uint buffer);
	void glDeleteBuffersARB (int n, GLuint* buffers);
	void glGenBuffersARB (int n, GLuint* buffers);
	ubyte glIsBufferARB (uint buffer);
	void glBufferDataARB (uint target, int size, GLvoid* data, uint usage);
	void glBufferSubDataARB (uint target, int offset, int size, GLvoid* data);
	void glGetBufferSubDataARB (uint target, int offset, int size, GLvoid* data);
	GLvoid* glMapBufferARB (uint target, uint access);
	ubyte glUnmapBufferARB (uint target);
	void glGetBufferParameterivARB (uint target, uint pname, GLint* params);
	void glGetBufferPointervARB (uint target, uint pname, GLvoid** params);
	void glDrawBuffersARB (int n, GLenum* bufs);
	void glBlendColorEXT (float dummy, float dummy, float dummy, float dummy);
	void glBlendEquationEXT (uint dummy);
	void glColorTableEXT (uint dummy, uint dummy, int dummy, uint dummy, uint dummy, GLvoid* dummy);
	void glColorSubTableEXT (uint dummy, int dummy, int dummy, uint dummy, uint dummy, GLvoid* dummy);
	void glGetColorTableEXT (uint dummy, uint dummy, uint dummy, GLvoid* dummy);
	void glGetColorTableParameterivEXT (uint dummy, uint dummy, GLint* dummy);
	void glGetColorTableParameterfvEXT (uint dummy, uint dummy, GLfloat* dummy);
	void glLockArraysEXT (int dummy, int dummy);
	void glUnlockArraysEXT ();
	void glDrawRangeElementsEXT (uint dummy, uint dummy, uint dummy, int dummy, uint dummy, GLvoid* dummy);
	void glSecondaryColor3bEXT (byte dummy, byte dummy, byte dummy);
	void glSecondaryColor3bvEXT (char* dummy);
	void glSecondaryColor3dEXT (double dummy, double dummy, double dummy);
	void glSecondaryColor3dvEXT (GLdouble* dummy);
	void glSecondaryColor3fEXT (float dummy, float dummy, float dummy);
	void glSecondaryColor3fvEXT (GLfloat* dummy);
	void glSecondaryColor3iEXT (int dummy, int dummy, int dummy);
	void glSecondaryColor3ivEXT (GLint* dummy);
	void glSecondaryColor3sEXT (short dummy, short dummy, short dummy);
	void glSecondaryColor3svEXT (GLshort* dummy);
	void glSecondaryColor3ubEXT (ubyte dummy, ubyte dummy, ubyte dummy);
	void glSecondaryColor3ubvEXT (char* dummy);
	void glSecondaryColor3uiEXT (uint dummy, uint dummy, uint dummy);
	void glSecondaryColor3uivEXT (GLuint* dummy);
	void glSecondaryColor3usEXT (ushort dummy, ushort dummy, ushort dummy);
	void glSecondaryColor3usvEXT (GLushort* dummy);
	void glSecondaryColorPointerEXT (int dummy, uint dummy, int dummy, GLvoid* dummy);
	void glMultiDrawArraysEXT (uint dummy, GLint* dummy, GLsizei* dummy, int dummy);
	void glMultiDrawElementsEXT (uint dummy, GLsizei* dummy, uint dummy, GLvoid** dummy, int dummy);
	void glFogCoordfEXT (float dummy);
	void glFogCoordfvEXT (GLfloat* dummy);
	void glFogCoorddEXT (double dummy);
	void glFogCoorddvEXT (GLdouble* dummy);
	void glFogCoordPointerEXT (uint dummy, int dummy, GLvoid* dummy);
	void glBlendFuncSeparateEXT (uint dummy, uint dummy, uint dummy, uint dummy);
	void glActiveStencilFaceEXT (uint face);
	void glDepthBoundsEXT (double zmin, double zmax);
	void glBlendEquationSeparateEXT (uint modeRGB, uint modeAlpha);
	ubyte glIsRenderbufferEXT (uint renderbuffer);
	void glBindRenderbufferEXT (uint target, uint renderbuffer);
	void glDeleteRenderbuffersEXT (int n, GLuint* renderbuffers);
	void glGenRenderbuffersEXT (int n, GLuint* renderbuffers);
	void glRenderbufferStorageEXT (uint target, uint internalformat, int width, int height);
	void glGetRenderbufferParameterivEXT (uint target, uint pname, GLint* params);
	ubyte glIsFramebufferEXT (uint framebuffer);
	void glBindFramebufferEXT (uint target, uint framebuffer);
	void glDeleteFramebuffersEXT (int n, GLuint* framebuffers);
	void glGenFramebuffersEXT (int n, GLuint* framebuffers);
	uint glCheckFramebufferStatusEXT (uint target);
	void glFramebufferTexture1DEXT (uint target, uint attachment, uint textarget, uint texture, int level);
	void glFramebufferTexture2DEXT (uint target, uint attachment, uint textarget, uint texture, int level);
	void glFramebufferTexture3DEXT (uint target, uint attachment, uint textarget, uint texture, int level, int zoffset);
	void glFramebufferRenderbufferEXT (uint target, uint attachment, uint renderbuffertarget, uint renderbuffer);
	void glGetFramebufferAttachmentParameterivEXT (uint target, uint attachment, uint pname, GLint* params);
	void glGenerateMipmapEXT (uint target);
	void glBlitFramebufferEXT (int srcX0, int srcY0, int srcX1, int srcY1, int dstX0, int dstY0, int dstX1, int dstY1, uint mask, uint filter);
	void glRenderbufferStorageMultisampleEXT (uint target, int samples, uint internalformat, int width, int height);
	void glProgramParameteriEXT (uint program, uint pname, int value);
	void glFramebufferTextureEXT (uint target, uint attachment, uint texture, int level);
	void glFramebufferTextureLayerEXT (uint target, uint attachment, uint texture, int level, int layer);
	void glFramebufferTextureFaceEXT (uint target, uint attachment, uint texture, int level, uint face);
	void glBindBufferRangeEXT (uint target, uint index, uint buffer, int offset, int size);
	void glBindBufferOffsetEXT (uint target, uint index, uint buffer, int offset);
	void glBindBufferBaseEXT (uint target, uint index, uint buffer);
	void glBeginTransformFeedbackEXT (uint primitiveMode);
	void glEndTransformFeedbackEXT ();
	void glTransformFeedbackVaryingsEXT (uint program, int count, GLchar** varyings, uint bufferMode);
	void glGetTransformFeedbackVaryingEXT (uint program, uint index, int bufSize, GLsizei* length, GLsizei* size, GLenum* type, char* name);
	void glGetIntegerIndexedvEXT (uint param, uint index, GLint* values);
	void glGetBooleanIndexedvEXT (uint param, uint index, char* values);
	void glUniformBufferEXT (uint program, int location, uint buffer);
	int glGetUniformBufferSizeEXT (uint program, int location);
	int glGetUniformOffsetEXT (uint program, int location);
	void glClearColorIiEXT (int r, int g, int b, int a);
	void glClearColorIuiEXT (uint r, uint g, uint b, uint a);
	void glTexParameterIivEXT (uint target, uint pname, GLint* params);
	void glTexParameterIuivEXT (uint target, uint pname, GLuint* params);
	void glGetTexParameterIivEXT (uint target, uint pname, GLint* params);
	void glGetTexParameterIiuvEXT (uint target, uint pname, GLuint* params);
	void glVertexAttribI1iEXT (uint index, int x);
	void glVertexAttribI2iEXT (uint index, int x, int y);
	void glVertexAttribI3iEXT (uint index, int x, int y, int z);
	void glVertexAttribI4iEXT (uint index, int x, int y, int z, int w);
	void glVertexAttribI1uiEXT (uint index, uint x);
	void glVertexAttribI2uiEXT (uint index, uint x, uint y);
	void glVertexAttribI3uiEXT (uint index, uint x, uint y, uint z);
	void glVertexAttribI4uiEXT (uint index, uint x, uint y, uint z, uint w);
	void glVertexAttribI1ivEXT (uint index, GLint* v);
	void glVertexAttribI2ivEXT (uint index, GLint* v);
	void glVertexAttribI3ivEXT (uint index, GLint* v);
	void glVertexAttribI4ivEXT (uint index, GLint* v);
	void glVertexAttribI1uivEXT (uint index, GLuint* v);
	void glVertexAttribI2uivEXT (uint index, GLuint* v);
	void glVertexAttribI3uivEXT (uint index, GLuint* v);
	void glVertexAttribI4uivEXT (uint index, GLuint* v);
	void glVertexAttribI4bvEXT (uint index, char* v);
	void glVertexAttribI4svEXT (uint index, GLshort* v);
	void glVertexAttribI4ubvEXT (uint index, char* v);
	void glVertexAttribI4usvEXT (uint index, GLushort* v);
	void glVertexAttribIPointerEXT (uint index, int size, uint type, int stride, GLvoid* pointer);
	void glGetVertexAttribIivEXT (uint index, uint pname, GLint* params);
	void glGetVertexAttribIuivEXT (uint index, uint pname, GLuint* params);
	void glUniform1uiEXT (int location, uint v0);
	void glUniform2uiEXT (int location, uint v0, uint v1);
	void glUniform3uiEXT (int location, uint v0, uint v1, uint v2);
	void glUniform4uiEXT (int location, uint v0, uint v1, uint v2, uint v3);
	void glUniform1uivEXT (int location, int count, GLuint* value);
	void glUniform2uivEXT (int location, int count, GLuint* value);
	void glUniform3uivEXT (int location, int count, GLuint* value);
	void glUniform4uivEXT (int location, int count, GLuint* value);
	void glGetUniformuivEXT (uint program, int location, GLuint* params);
	void glBindFragDataLocationEXT (uint program, uint colorNumber, char* name);
	int glGetFragDataLocationEXT (uint program, char* name);
	void glTextureRangeAPPLE (uint target, int length, GLvoid* pointer);
	void glGetTexParameterPointervAPPLE (uint target, uint pname, GLvoid** params);
	void glVertexArrayRangeAPPLE (int length, GLvoid* pointer);
	void glFlushVertexArrayRangeAPPLE (int length, GLvoid* pointer);
	void glVertexArrayParameteriAPPLE (uint pname, int param);
	void glBindVertexArrayAPPLE (uint id);
	void glDeleteVertexArraysAPPLE (int n, GLuint* ids);
	void glGenVertexArraysAPPLE (int n, GLuint* ids);
	ubyte glIsVertexArrayAPPLE (uint id);
	void glGenFencesAPPLE (int n, GLuint* fences);
	void glDeleteFencesAPPLE (int n, GLuint* fences);
	void glSetFenceAPPLE (uint fence);
	ubyte glIsFenceAPPLE (uint fence);
	ubyte glTestFenceAPPLE (uint fence);
	void glFinishFenceAPPLE (uint fence);
	ubyte glTestObjectAPPLE (uint object, uint name);
	void glFinishObjectAPPLE (uint object, uint name);
	void glElementPointerAPPLE (uint type, GLvoid* pointer);
	void glDrawElementArrayAPPLE (uint mode, int first, int count);
	void glDrawRangeElementArrayAPPLE (uint mode, uint start, uint end, int first, int count);
	void glMultiDrawElementArrayAPPLE (uint mode, GLint* first, GLsizei* count, int primcount);
	void glMultiDrawRangeElementArrayAPPLE (uint mode, uint start, uint end, GLint* first, GLsizei* count, int primcount);
	void glFlushRenderAPPLE ();
	void glFinishRenderAPPLE ();
	void glSwapAPPLE ();
	void glEnableVertexAttribAPPLE (uint index, uint pname);
	void glDisableVertexAttribAPPLE (uint index, uint pname);
	ubyte glIsVertexAttribEnabledAPPLE (uint index, uint pname);
	void glMapVertexAttrib1dAPPLE (uint index, uint size, double u1, double u2, int stride, int order, GLdouble* points);
	void glMapVertexAttrib1fAPPLE (uint index, uint size, float u1, float u2, int stride, int order, GLfloat* points);
	void glMapVertexAttrib2dAPPLE (uint index, uint size, double u1, double u2, int ustride, int uorder, double v1, double v2, int vstride, int vorder, GLdouble* points);
	void glMapVertexAttrib2fAPPLE (uint index, uint size, float u1, float u2, int ustride, int uorder, float v1, float v2, int vstride, int vorder, GLfloat* points);
	void glBufferParameteriAPPLE (uint target, uint pname, int param);
	void glFlushMappedBufferRangeAPPLE (uint target, int offset, int size);
	uint glObjectPurgeableAPPLE (uint objectType, uint name, uint option);
	uint glObjectUnpurgeableAPPLE (uint objectType, uint name, uint option);
	void glGetObjectParameterivAPPLE (uint objectType, uint name, uint pname, GLint* params);
	void glPNTrianglesiATI (uint pname, int param);
	void glPNTrianglesfATI (uint pname, float param);
	void glBlendEquationSeparateATI (uint equationRGB, uint equationAlpha);
	void glStencilOpSeparateATI (uint face, uint sfail, uint dpfail, uint dppass);
	void glStencilFuncSeparateATI (uint frontfunc, uint backfunc, int ref_, uint mask);
	void glPNTrianglesiATIX (uint pname, int param);
	void glPNTrianglesfATIX (uint pname, float param);
	void glCombinerParameterfvNV (uint dummy, GLfloat* dummy);
	void glCombinerParameterfNV (uint dummy, float dummy);
	void glCombinerParameterivNV (uint dummy, GLint* dummy);
	void glCombinerParameteriNV (uint dummy, int dummy);
	void glCombinerInputNV (uint dummy, uint dummy, uint dummy, uint dummy, uint dummy, uint dummy);
	void glCombinerOutputNV (uint dummy, uint dummy, uint dummy, uint dummy, uint dummy, uint dummy, uint dummy, ubyte dummy, ubyte dummy, ubyte dummy);
	void glFinalCombinerInputNV (uint dummy, uint dummy, uint dummy, uint dummy);
	void glGetCombinerInputParameterfvNV (uint dummy, uint dummy, uint dummy, uint dummy, GLfloat* dummy);
	void glGetCombinerInputParameterivNV (uint dummy, uint dummy, uint dummy, uint dummy, GLint* dummy);
	void glGetCombinerOutputParameterfvNV (uint dummy, uint dummy, uint dummy, GLfloat* dummy);
	void glGetCombinerOutputParameterivNV (uint dummy, uint dummy, uint dummy, GLint* dummy);
	void glGetFinalCombinerInputParameterfvNV (uint dummy, uint dummy, GLfloat* dummy);
	void glGetFinalCombinerInputParameterivNV (uint dummy, uint dummy, GLint* dummy);
	void glCombinerStageParameterfvNV (uint dummy, uint dummy, GLfloat* dummy);
	void glGetCombinerStageParameterfvNV (uint dummy, uint dummy, GLfloat* dummy);
	void glPointParameteriNV (uint pname, int param);
	void glPointParameterivNV (uint pname, GLint* params);
}