/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.quartzcore.CAOpenGLLayer;

import dstep.objc.bridge.Bridge;
import dstep.objc.objc;
import dstep.opengl.OpenGL;
import dstep.quartzcore.CALayer;
import dstep.quartzcore.CVBase;

class CAOpenGLLayer : CALayer
{
	mixin (ObjcWrap);

	bool isAsynchronous ()
	{
		return invokeObjcSelf!(bool, "isAsynchronous");
	}

	void setAsynchronous (bool arg0)
	{
		return invokeObjcSelf!(void, "setAsynchronous:", bool)(arg0);
	}
	
	alias setAsynchronous isAsynchronous;

	bool canDrawInCGLContext (CGLContextObj ctx, CGLPixelFormatObj pf, double t, CVTimeStamp* ts)
	{
		return invokeObjcSelf!(bool, "canDrawInCGLContext:pixelFormat:forLayerTime:displayTime:", CGLContextObj, CGLPixelFormatObj, double, CVTimeStamp*)(ctx, pf, t, ts);
	}

	void drawInCGLContext (CGLContextObj ctx, CGLPixelFormatObj pf, double t, CVTimeStamp* ts)
	{
		return invokeObjcSelf!(void, "drawInCGLContext:pixelFormat:forLayerTime:displayTime:", CGLContextObj, CGLPixelFormatObj, double, CVTimeStamp*)(ctx, pf, t, ts);
	}

	CGLPixelFormatObj copyCGLPixelFormatForDisplayMask (uint mask)
	{
		return invokeObjcSelf!(CGLPixelFormatObj, "copyCGLPixelFormatForDisplayMask:", uint)(mask);
	}

	void releaseCGLPixelFormat (CGLPixelFormatObj pf)
	{
		return invokeObjcSelf!(void, "releaseCGLPixelFormat:", CGLPixelFormatObj)(pf);
	}

	CGLContextObj copyCGLContextForPixelFormat (CGLPixelFormatObj pf)
	{
		return invokeObjcSelf!(CGLContextObj, "copyCGLContextForPixelFormat:", CGLPixelFormatObj)(pf);
	}

	void releaseCGLContext (CGLContextObj ctx)
	{
		return invokeObjcSelf!(void, "releaseCGLContext:", CGLContextObj)(ctx);
	}
}

