/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.quartzcore.CATransaction;

import dstep.foundation.NSObject;
import dstep.foundation.NSString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;
import dstep.quartzcore.CABase;

import bindings = dstep.quartzcore.CATransaction_bindings;

private
{
	NSString kCATransactionAnimationDuration_;
	NSString kCATransactionDisableActions_;
}

NSString kCATransactionAnimationDuration ()
{
	if (kCATransactionAnimationDuration_)
		return kCATransactionAnimationDuration_;

	return kCATransactionAnimationDuration_ = new NSString(bindings.kCATransactionAnimationDuration);
}

NSString kCATransactionDisableActions ()
{
	if (kCATransactionDisableActions_)
		return kCATransactionDisableActions_;

	return kCATransactionDisableActions_ = new NSString(bindings.kCATransactionDisableActions);
}

class CATransaction : NSObject
{
	mixin (ObjcWrap);

	static void begin ()
	{
		return invokeObjcSelfClass!(void, "begin");
	}

	static void commit ()
	{
		return invokeObjcSelfClass!(void, "commit");
	}

	static void flush ()
	{
		return invokeObjcSelfClass!(void, "flush");
	}

	static Object valueForKey (NSString key)
	{
		return invokeObjcSelfClass!(Object, "valueForKey:", NSString)(key);
	}

	static void setValue (Object anObject, NSString key)
	{
		return invokeObjcSelfClass!(void, "setValue:forKey:", Object, NSString)(anObject, key);
	}
}

