/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 22, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.security.oidscert;

import dstep.security.cssmconfig;
import dstep.security.cssmtype;
import dstep.security.oidsbase;

extern (C):

extern const CSSM_OID

CSSMOID_X509V3SignedCertificate,
CSSMOID_X509V3SignedCertificateCStruct,
CSSMOID_X509V3Certificate,
CSSMOID_X509V3CertificateCStruct,
CSSMOID_X509V1Version,
CSSMOID_X509V1SerialNumber,
CSSMOID_X509V1IssuerName,			// normalized & encoded
CSSMOID_X509V1IssuerNameStd,		// encoded
CSSMOID_X509V1IssuerNameCStruct,	// CSSM_X509_NAME
CSSMOID_X509V1IssuerNameLDAP,
CSSMOID_X509V1ValidityNotBefore,
CSSMOID_X509V1ValidityNotAfter,
CSSMOID_X509V1SubjectName,			// normalized & encoded
CSSMOID_X509V1SubjectNameStd,		// encoded
CSSMOID_X509V1SubjectNameCStruct,	// CSSM_X509_NAME
CSSMOID_X509V1SubjectNameLDAP,
CSSMOID_CSSMKeyStruct,
CSSMOID_X509V1SubjectPublicKeyCStruct,
CSSMOID_X509V1SubjectPublicKeyAlgorithm,
CSSMOID_X509V1SubjectPublicKeyAlgorithmParameters,
CSSMOID_X509V1SubjectPublicKey,
CSSMOID_X509V1CertificateIssuerUniqueId,
CSSMOID_X509V1CertificateSubjectUniqueId,
CSSMOID_X509V3CertificateExtensionsStruct,
CSSMOID_X509V3CertificateExtensionsCStruct,
CSSMOID_X509V3CertificateNumberOfExtensions,
CSSMOID_X509V3CertificateExtensionStruct,
CSSMOID_X509V3CertificateExtensionCStruct,
CSSMOID_X509V3CertificateExtensionId,
CSSMOID_X509V3CertificateExtensionCritical,
CSSMOID_X509V3CertificateExtensionType,
CSSMOID_X509V3CertificateExtensionValue,

/* Signature OID Fields */
CSSMOID_X509V1SignatureStruct,
CSSMOID_X509V1SignatureCStruct,
CSSMOID_X509V1SignatureAlgorithm,
CSSMOID_X509V1SignatureAlgorithmTBS,
CSSMOID_X509V1SignatureAlgorithmParameters,
CSSMOID_X509V1Signature,

/* Extension OID Fields */
CSSMOID_SubjectSignatureBitmap,
CSSMOID_SubjectPicture,
CSSMOID_SubjectEmailAddress,
CSSMOID_UseExemptions;

/*** 
*** Apple addenda
***/

/* 
* Standard Cert and CRL extensions.
*/
extern const CSSM_OID
CSSMOID_SubjectDirectoryAttributes,
CSSMOID_SubjectKeyIdentifier,
CSSMOID_KeyUsage,
CSSMOID_PrivateKeyUsagePeriod,
CSSMOID_SubjectAltName,
CSSMOID_IssuerAltName,
CSSMOID_BasicConstraints,
CSSMOID_CrlNumber,
CSSMOID_CrlReason,
CSSMOID_HoldInstructionCode,
CSSMOID_InvalidityDate,
CSSMOID_DeltaCrlIndicator,
CSSMOID_IssuingDistributionPoint,
CSSMOID_IssuingDistributionPoints,
CSSMOID_CertIssuer,
CSSMOID_NameConstraints,
CSSMOID_CrlDistributionPoints,
CSSMOID_CertificatePolicies,
CSSMOID_PolicyMappings,
CSSMOID_PolicyConstraints,
CSSMOID_AuthorityKeyIdentifier,
CSSMOID_ExtendedKeyUsage,
CSSMOID_AuthorityInfoAccess,
CSSMOID_BiometricInfo,
CSSMOID_QC_Statements,
CSSMOID_SubjectInfoAccess,
CSSMOID_ExtendedKeyUsageAny,
CSSMOID_ServerAuth,
CSSMOID_ClientAuth,
CSSMOID_ExtendedUseCodeSigning,
CSSMOID_EmailProtection,
CSSMOID_TimeStamping,
CSSMOID_OCSPSigning,
CSSMOID_KERBv5_PKINIT_KP_CLIENT_AUTH,
CSSMOID_KERBv5_PKINIT_KP_KDC,
CSSMOID_EKU_IPSec,
CSSMOID_DOTMAC_CERT_EXTENSION,
CSSMOID_DOTMAC_CERT_IDENTITY,
CSSMOID_DOTMAC_CERT_EMAIL_SIGN,
CSSMOID_DOTMAC_CERT_EMAIL_ENCRYPT,
CSSMOID_APPLE_CERT_POLICY,
CSSMOID_DOTMAC_CERT_POLICY,
CSSMOID_APPLE_EKU_CODE_SIGNING, 
CSSMOID_APPLE_EKU_CODE_SIGNING_DEV,
CSSMOID_APPLE_EKU_RESOURCE_SIGNING,
CSSMOID_APPLE_EKU_ICHAT_SIGNING,
CSSMOID_APPLE_EKU_ICHAT_ENCRYPTION,
CSSMOID_APPLE_EKU_SYSTEM_IDENTITY
;

/*
* Netscape extensions.
*/
extern const CSSM_OID	
CSSMOID_NetscapeCertType,
CSSMOID_NetscapeCertSequence,
CSSMOID_NetscapeSGC;

extern const CSSM_OID CSSMOID_MicrosoftSGC;

